#pragma once

#include <cstdint>
#include <cstddef>

namespace dtb {

    struct DtbMeta {
        void *base;
        size_t size;
        uint32_t version;
        uint32_t last_compatible_version;
        uint32_t boot_cpu_id;
    };

    struct ReservedRegion {
        uintptr_t address;
        size_t size;
    };

    struct DeviceTree {
        DtbMeta meta;
        void *memory_reservation_block;
        void *structure_block;
        void *strings_block;
    };

    int validate_and_parse_header(DeviceTree &dt, void *base);

    void print_reserved_regions(DeviceTree dt);

    void print_structure_block(DeviceTree dt);

}  // End namespace dtb
