#pragma once

#include "registers.h"
#include <stdint.h>

namespace drivers {
namespace sunxi_d1_pinctrl {

enum Bank {
    PA,
    PB,
    PC,
    PD,
    PE,
    PF,
    PG,
};

struct SunxiD1Pinctrl {
    SunxiD1Pinctrl(void * const addr);

    void set_pin_mode(
            const Bank bank,
            const uint8_t pin,
            const uint8_t mode);
    void set_pin_state(
            const Bank bank,
            const uint8_t pin,
            const bool state);
    bool get_pin_state(
            const Bank bank,
            const uint8_t pin);

  private:
    Registers &m_registers;
};

}  // End namespace sunxi_d1_pinctrl
}  // End namespace drivers
